package photowrapper;

import main.java.com.google.android.gms.samples.vision.face.photo.FaceView;


import android.content.Context;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Permissions;

import android.view.View;
import android.graphics.Color;


import android.app.Activity;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.util.SparseArray;
import android.widget.Toast;

import main.java.com.google.android.gms.samples.vision.face.patch.SafeFaceDetector;
import com.google.android.gms.vision.Detector;
import com.google.android.gms.vision.Frame;
import com.google.android.gms.vision.face.Face;
import com.google.android.gms.vision.face.FaceDetector;
import com.google.android.gms.vision.face.FaceDetector.Builder;

import com.google.android.gms.vision.face.Landmark;

import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;

//@ActivityObject
@Events(values={"face_found(LandMarks As Object, IsLeftEyeOpenProbability As Float, IsRightEyeOpenProbability As Float, IsSmilingProbability As Float, EulerY As Float, EulerZ As Float, iD As Int)"})
@Author("Github: Clayton Wilkinson, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("AndroidVisionFaceView")
@DependsOn(values={"android-support-v4", "android-support-v7-appcompat", "google-play-services", "android-support-design"})
@Permissions(values={"android.permission.CAMERA","android.permission.WRITE_EXTERNAL_STORAGE","android.hardware.camera","android.hardware.camera.autofocus","android.permission.VIBRATE","android.permission.FLASHLIGHT"})
public class photoWrapper extends ViewWrapper<FaceView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private FaceView cv;
	//FaceDetector detector;
	//FaceDetector.Builder builder;
	
	/**
     * Initialize with the name of the Event that will be raised when a date is clicked,
     * the number of years backwards from the present date (0, 1, 2, 3......), and
     * the number of years forward from the present date (0, 1, 2, 3......)	 
     */		
	public void Initialize(BA ba, String EventName) {

		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new FaceView(ba.context, null);
		//builder = new FaceDetector.Builder(ba.context);
        this.setObject(cv);
		
         addCallBack();
//       init1();
 	}
	
	
	public static final int NO_LANDMARKS = 0;
	public static final int ALL_LANDMARKS = 1;
	private static final int NO_CLASSIFICATIONS = 0;
	private static final int ALL_CLASSIFICATIONS = 1;
	private static final int FAST_MODE = 0;
	private static final int ACCURATE_MODE = 1;	
	
	
	private int landmarkType = 1;
    public void setLandmarkType(int landmarkType) {
      this.landmarkType = landmarkType;
    }
    
	private boolean prominentFaceOnly = false;
    public void setProminentFaceOnly(boolean prominentFaceOnly) {
      this.prominentFaceOnly = prominentFaceOnly;
    }
    
	private int classificationType = 1;
	@Hide
    public void setClassificationType(int classificationType) {
      this.classificationType = classificationType;
    }
    
	private boolean trackingEnabled = false;
	@Hide
    public void setTrackingEnabled(boolean trackingEnabled) {
      this.trackingEnabled = trackingEnabled;
    }
    
	private int mode = 1;
	@Hide
    public void setMode(int mode) {
      this.mode = mode;
    }
    
	private float proportionalMinFaceSize = 0.5f;
    public void setMinFaceSize(float proportionalMinFaceSize) {
      this.proportionalMinFaceSize = proportionalMinFaceSize;
    }
	
	private int circleColor = Color.GREEN;
	public void setCircleColor(int circleColor) {
		cv.setCircleColor(circleColor);
	}
	
	private int circleWidth = 5;
	public void setCircleWidth(int circleWidth) {
		cv.setCircleWidth(circleWidth);
	}	
	
	private int circleDiameter = 10;
	public void setCircleDiameter(int circleDiameter) {
		cv.setCircleDiameter(circleDiameter);
	}			
     
    public void build() {

	
        FaceDetector detector = new FaceDetector.Builder(BA.applicationContext)
                .setTrackingEnabled(trackingEnabled)
                .setLandmarkType(landmarkType)
				.setMode(mode)
				.setMinFaceSize(proportionalMinFaceSize)
				.setClassificationType(classificationType)
				.setProminentFaceOnly(prominentFaceOnly)
                .build();	

        Detector<Face> safeDetector = new SafeFaceDetector(detector);

        // Create a frame from the bitmap and run face detection on the frame.
        Frame frame = new Frame.Builder().setBitmap(photo).build();
        SparseArray<Face> faces = safeDetector.detect(frame);

        if (!safeDetector.isOperational()) {
            // Note: The first time that an app using face API is installed on a device, GMS will
            // download a native library to the device in order to do detection.  Usually this
            // completes before the app is run for the first time.  But if that download has not yet
            // completed, then the above call will not detect any faces.
            //
            // isOperational() can be used to check if the required native library is currently
            // available.  The detector will automatically become operational once the library
            // download completes on device.
            //Log.w(TAG, "Face detector dependencies are not yet available.");

            // Check for low storage.  If there is low storage, the native library will not be
            // downloaded, so detection will not become operational.
            IntentFilter lowstorageFilter = new IntentFilter(Intent.ACTION_DEVICE_STORAGE_LOW);
/*             boolean hasLowStorage = registerReceiver(null, lowstorageFilter) != null;

            if (hasLowStorage) {
                Toast.makeText(ba.applicationContext, "low storage error", Toast.LENGTH_LONG).show();
                
            } */
        }

        cv.setContent(photo, faces);

        // Although detector may be used multiple times for different images, it should be released
        // when it is no longer needed in order to free native resources.
        safeDetector.release();	  
    }	
	
	
    @Hide
    public void addCallBack(){
        cv.setCallback(new FaceView.Callback() {
            @Override
            public void face_found() {

				if (ba.subExists(eventName + "_face_found")) {
					ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_face_found", true, new Object[]{getLandmarks(), cv.getIsLeftEyeOpenProbability(),
					                                                                                                     cv.getIsRightEyeOpenProbability(), cv.getIsSmilingProbability(), 
																														 cv.getEulerY(), cv.getEulerZ(), cv.getId()});
				}	
            }

        });
    }		
	
	
	@Hide
	public float getEulerY() {
	  return cv.getEulerY();
	}

	@Hide
	public float getEulerZ() {
	  return cv.getEulerZ();
	}

	@Hide
	public ArrayList<String> getLandmarks() {
       return cv.getLandmarks();
	}

	@Hide
	public float getIsLeftEyeOpenProbability() {
	  return cv.getIsLeftEyeOpenProbability();
	}

	@Hide
	public float getIsRightEyeOpenProbability() {
	  return cv.getIsRightEyeOpenProbability();
	}

	@Hide
	public float getIsSmilingProbability() {
	  return cv.getIsSmilingProbability();
	}

	@Hide
	public int getId() {
	  return cv.getId();
	}	
	
		
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden. 
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
	private Bitmap photo = null;
    public void setPhoto(Bitmap photo) {
	   this.photo = photo;
    }	
		

   
}
